/*;  khgrid.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 2.1 $$ {\rhead{\sl khgrid.h\quad\thepage}} */
/*;  $$Date: 1998/07/16 09:28:19 $$  */
/*;  $$Source: /home/shiiba/KhProgDevelop/KhC++Lib/matrix/khgrid.h,v $$  */
/*;  $$RCShost: tone.kuciv.kyoto-u.ac.jp $$ */

/*

KhGrid<Type>  Type ǤȤʻҷΥǡ¤ɽ饹
Ǥ

㤨СKhGrid<Complex> a(2,3); ȡa(i,j), i=0, 1, j=0,
1, 2 6Ĥ Complex ǤĳʻҷΥǡɽޤ

a(i,j) ϡijǤؤ const ʻȤ֤ޤ(Rev. 2.1 Ǥ
Τ褦ѹޤϡa(i,j) ϡijǤؤλȤ
֤Ƥޤ) a(i,j) ͤ뤳ȤϤǤޤij
ǤͤȤϡ

a.Ref(i,j) = ...

Τ褦ˤƤa.Ref(i,j) ϡijǤؤλȤ֤


KhGenGrid<Type> ϡźɬ1ϤޤʤγʻҷΥǡ
¤ɽΥ饹ǤKhGrid<Type> ѾƺƤ
ޤ

*/

#ifndef MSGRID_H
#define MSGRID_H

#include <stddef.h>
#include <limits.h>

#include "khboolean.h"
// #include "khstring.h"
#include "khsimple.h"
#include "kherror.h"

//-----------------------------------
// KhGrid
//      A two-dimensional array class
//-----------------------------------

template <class D>
class KhGrid
{
 public:
  // constructors
  KhGrid();

  KhGrid (
   size_t rows,
   size_t cols
   );

  KhGrid (
   const KhGrid<D> & m
   );

  // destructors
  ~KhGrid();

  // assignment operator
  void operator = (
    const KhGrid<D> & m
    );

  void operator = (
    const D * array
    //
    // copies "array" to the data member array "Data"
    //
    );

  // interrogation
  size_t GetRows() const;
  size_t GetCols() const;

  KhBoolean IsVector() const;
  KhBoolean IsRowVector() const;
  KhBoolean IsColVector() const;
  KhBoolean IsSquare() const;

  // retrieve elements
  const D& operator () ( // returns the const reference to the
			 // (row, col) element
    size_t row,
    size_t col
    //
    // Note that the property "const" is given to this member
    // function.
    //
    ) const;

  D& Ref(	  // returns the reference to the (row, col) element
    size_t row,
    size_t col
    );

  D& Elem(	  // internal function w/o exception check!
    size_t row,
    size_t col
    ) const;

  // apply a function to each element
  void Apply(
    D (* func)(const D & n)
    );

 friend KhGrid<D> Apply(
   const KhGrid<D> & m,
   D (* func)(const D & n)
   );

  // fill matrix with specific value
  void Fill(
    const D & x
    );

  // create a row matrix
  KhGrid<D> VectorRow(
    size_t row
    );

  // create a column vector
  KhGrid<D> VectorCol(
    size_t col
    );

  // transpose a matrix
  KhGrid<D> Transpose();

  // change size (destroying contents)
  void Resize(
   size_t rows,
   size_t cols
   );

 protected:
  D * Data;
  size_t R;
  size_t C;
  size_t N;

  size_t Index(
    size_t row,
    size_t col
    ) const;

};

template <class D>
inline size_t KhGrid<D>::Index(
  size_t row,
  size_t col
) const
{
  return (row * C + col);
}

// interrogation
template <class D>
inline size_t KhGrid<D>::GetRows() const
{
  return R;
}

template <class D>
inline size_t KhGrid<D>::GetCols() const
{
  return C;
}

template <class D>
inline KhBoolean KhGrid<D>::IsVector() const
{
  if ((R == 1) || (C == 1))
    return YES;
  else
    return NO;
}

template <class D>
inline KhBoolean KhGrid<D>::IsRowVector() const
{
  if (C == 1)
    return YES;
  else
    return NO;
}

template <class D>
inline KhBoolean KhGrid<D>::IsColVector() const
{
  if (R == 1)
    return YES;
  else
    return NO;
}

template <class D>
inline KhBoolean KhGrid<D>::IsSquare() const
{
  if (R == C)
    return YES;
  else
    return NO;
}

template <class D>
inline D & KhGrid<D>::Elem(
  size_t row,
  size_t col
) const
{
  return Data[row * C + col];
}

template <class D>
class KhGenGrid : public KhGrid<D>
{
  // źϰϤˤĤư̲줿åɡ
  // źβ¤Ǥޤ
  // KhGenGrid<double> A(1,3, 1,4);
  // ϡ34ιǡź1Ϥޤޤ

 private:
  int Imin;
  int Jmin;

 public:
  KhGenGrid(		// 󥹥ȥ饯
    int IminVal,	// źβ
    int ImaxVal,	// źξ
    int JminVal,	// 裲źβ
    int JmaxVal		// 裲źξ
    )
    : KhGrid<D>(ImaxVal-IminVal+1, JmaxVal-JminVal+1)
  {
    Imin = IminVal; Jmin = JminVal;
  };

  KhGenGrid(		// ԡ󥹥ȥ饯
    const KhGenGrid<D>& a
    )
    : KhGrid<D>(a), Imin(a.Imin), Jmin(a.Jmin) { }

  KhGenGrid<D>& operator=( // 黻
    const KhGenGrid<D>& a
    )
  {
    if (this != &a)
      {
	KhGrid<D>::operator=(a);
	Imin = a.Imin;   Jmin = a.Jmin;
      }
    return *this;
  }

  D&
  Ref(			// ǤؤλȤ֤ؿ
    int rowVal,		// ֹ
    int colVal		// ֹ
    )
  {
    return Data[Index(rowVal-Imin,colVal-Jmin)];
  }
  D&
  Elem(			// ǤλȤ֤ؿźʤ
    int rowVal,		// ֹ
    int colVal		// ֹ
    )
  {
    return Data[(rowVal-Imin)*C+colVal-Jmin];
  }
  const D&
  operator()(		// ǤλȤ֤źꡣ
    int rowVal,		// ֹ
    int colVal		// ֹ
    ) const
  {
    return Data[Index(rowVal-Imin,colVal-Jmin)];
  }

  // źβ¤Ⱦ¤򶵤ؿ
  int GetRowmin() const { return Imin; }
  int GetColmin() const { return Jmin; }
  int GetRowmax() const { return Imin + R - 1; }
  int GetColmax() const { return Jmin + C - 1; }

  // ǥȥ饯
  ~KhGenGrid()
  {
    ;
//    delete [] Data;
  }
};

#endif

/*; end of file */
