/* rainOnCatchment.cc
----------------------------------------------------------------
   NX rainOnCatchment ̎
----------------------------------------------------------------
ver 1.2 : o͎ԊԊup^Őݒł悤ɕύX܂D
Jan. 5, 2006 modified by T.Sayama
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <fstream.h>

#include "ksedgefc2d.h"			// defines class Edge
#include "dfopen.h"				// defines function dataFileOpen
#include "rainOnCatchment.h"	// defines rainOnCatchment

void rainOnCatchment::Set_parameter(FILE* fp)
{
	int dt;						// (s) (o͎ԊԊu)

	char subfile[256];			// extractedNumFile
	char s1[256], s2[256], s[256];	 // s1 : edge connection t@CiOj
									 // s2 : edge connection t@Ci㔼j
									 // s : s1//ssubnum//s2
	char ssubnum[256];

	double xorig, yorig;		// 2~Jf[^̌_W (m)
	double dx, dy;				// 2~Jf[^̋ԊԊu (m)

	Boolean singlesub;			// P̕ΏۂƂꍇ F YES
								// ̕ΏۂƂꍇ F NO

	char buf[256];

	if (fscanf(fp, "%d", &dt) != 1)
	{
		Eprint(__FILE__, __LINE__);
			// rainOnCatchment::Set_parameter
			// can not read parameter file.
		Oprint();
		exit(1);
	}

	if (fgets(buf, 256, fp) == NULL)
	{
		Eprint(__FILE__, __LINE__);
			// rainOnCatchment::Set_parameter
			// can not read parameter file.
		Oprint();
		exit(1);
	}

	if (sscanf(buf, "%s %lf %lf %lf %lf", 
		s, &xorig, &yorig, &dx, &dy) == 5)		// P̕Ώ
	{
		singlesub = YES;
		numOfSubCatchment = 1;
	}
	else if (sscanf(buf, "%s %s %s %lf %lf %lf %lf", 
		subfile, s1, s2, &xorig, &yorig, &dx, &dy) == 7)	// ̕Ώ
	{
		singlesub = NO;
	}
	else
	{
		Eprint(__FILE__, __LINE__);
			// rainOnCatchment::Set_parameter
			// can not read parameter file.
		Oprint();
		exit(1);
	}

	assert(dt > 0); mDt = dt;
	assert(dx > 0.0); mDx = dx;
	assert(dy > 0.0); mDy = dy;

	mXorig = xorig;
	mYorig = yorig;

	if(singlesub == NO)
	{
		// 㗬̕ԍǂݍ
		FILE* fpSubNum;
		assert((fpSubNum = dataFileOpen(subfile)) != NULL);

		// [Number of Extracted Data] : numOfSubCatchment ̐ݒ

		while (fgets(buf, 256, fpSubNum) != NULL &&
		strncmp(buf, "[Number of Extracted Data]", 26) != 0) ;
		fgets(buf, 256, fpSubNum);
		assert(sscanf(buf, "%d", &numOfSubCatchment) == 1);
		mSubNum = new int[numOfSubCatchment];

		// [Data] : mSubNum ̐ݒ

		int subnum;
		while (fgets(buf, 256, fpSubNum) != NULL &&
			   strncmp(buf, "[Data]", 6) != 0) ;

		for (int i = 0; i < numOfSubCatchment; i++)
		{
			fgets(buf, 256, fpSubNum);
			assert(sscanf(buf, "%d", &subnum));
			mSubNum[i] = subnum;
		}
		fclose(fpSubNum);
	}

	// SĂ̕EdgeJEgD

	numOfTotalEdges = 0;
	for (int i = 0; i < numOfSubCatchment; i++)
	{
		if(singlesub == NO)
		{
			//ssubnum = atoi(mSubNum[i]);
			sprintf(ssubnum, "%d", mSubNum[i]);
			strcpy(s, s1);
			strcat(s, ssubnum);
			strcat(s, s2);
		}

		// edge connection file  open
		FILE* fpTopo;
		assert((fpTopo = dataFileOpen(s)) != NULL);

		while (fgets(buf, 256, fpTopo) != NULL &&
			   strncmp(buf, "[Number of Total Edges]", 23) != 0);

		int numOfEdges;				// GbW̐
		fgets(buf, 256, fpTopo);
		assert(sscanf(buf, "%d", &numOfEdges) == 1);
		//assert(numOfEdges > 0); numOfTotalEdges += numOfEdges;
		numOfTotalEdges += numOfEdges;
		fclose(fpTopo);
	}

	// SĂEdgeɑ΂ NX Edge mۂ

	assert((edgeArray = new Edge[numOfTotalEdges]) != NULL);


	// SĂEdgeɑ΂ mTopoDataType ݒ

	long j = 0;;		// edgeArray[j] : j < numOfTotalEdges;
	for (int i = 0; i < numOfSubCatchment; i++)
	{
		if(singlesub == NO)
		{
			// ssubnum = atoi(mSubNum[i]);
			sprintf(ssubnum, "%d", mSubNum[i]);
			strcpy(s, s1);
			strcat(s, ssubnum);
			strcat(s, s2);
		}

		// edge connection file  open
		FILE* fpTopo;
		assert((fpTopo = dataFileOpen(s)) != NULL);

		// [Data Format Name]: mTopoDataType ̐ݒ

		while (fgets(buf, 256, fpTopo) != NULL &&
			   strncmp(buf, "[Data Format Name]", 18) != 0) ;
		fgets(buf, 256, fpTopo);
		if (strncmp(buf, "edge connection V.2", 19) == 0)
		{
			mTopoDataType = 2;
		}
		else if (strncmp(buf, "edge connection V.3", 19) == 0)
		{
			mTopoDataType = 3;
		}
		else if (strncmp(buf, "edge connection V.4", 19) == 0)
		{
			mTopoDataType = 4;
		}
		else if (strncmp(buf, "edge connection V.5", 19) == 0)
		{
			mTopoDataType = 5;
		}
		else
		{
			Eprint(__FILE__, __LINE__);
				// KsEdgeFc2d::Set_parameter
				// Invalid topographic data format.
				// Topographic data must be edge connection V.{2/3/4/5} format.
			Oprint();
			exit(1);
		}

		while (fgets(buf, 256, fpTopo) != NULL &&
			   strncmp(buf, "[Number of Total Edges]", 23) != 0) ;

		fgets(buf, 256, fpTopo);
		int numOfEdges;
		assert(sscanf(buf, "%d", &numOfEdges) == 1);

		while (fgets(buf, 256, fpTopo) != NULL &&
			   strncmp(buf, "[Data]", 6) != 0) ;

		for (int i = 0; i < numOfEdges; i++)
		{
			edgeArray[j].TopographicData(fpTopo, mTopoDataType);
			j++;
		}
		fclose(fpTopo);
	}
	if(j != numOfTotalEdges)
	{
		printf("Wrong in numOfTotalEdges : j = %ld, numOfTotalEdges = %ld \n", j, numOfTotalEdges);
		exit(1);
	}

	sumRain = 0;
	mDDt = 300;

	int mod_temp = (int)(fmod((double)(mDt), (double)(mDDt)));
	if(mod_temp != 0)
	{
		printf("mDt : %d has to be a multiple number of mDDt : %d\n", mDt, mDDt);
		printf("mod_temp : %d\n", mod_temp);
		exit(1);
	}

	aveNum = (int)((double)(mDt) / (double)(mDDt));
}


Boolean rainOnCatchment::Initial_output(void)
{
    if (rp.Can_you_get_data(current_time, current_time) == NO) {
      return NO;
    }
	long CELLBLK = 5;			// 5x5  1 ubNƂ

	// eΖʑfЂǂ̊iqZf[^擾邩ׂĂ

	void* fdp; void* ldp;
	if (rp.Get_data_pack(fdp, current_time, ldp) == NO)
		return NO;

	// Jʃf[^ėāAsƗ̌𒲂ׂ
	time_t wt;
	KhDMatrix wRain;

	if (fdp != NULL)
	{
		wt = ((Data<KhDMatrix>*)fdp)->Data_time();
		wRain = ((Data<KhDMatrix>*)fdp)->Value();
	}
	else if (ldp != NULL)
	{
		wt = ((Data<KhDMatrix>*)ldp)->Data_time();
		wRain = ((Data<KhDMatrix>*)ldp)->Value();
	}
	else return NO;

	// ׂZ̐
	long xCellNum = wRain.GetRows(); // x 
	long yCellNum = wRain.GetCols(); // y 

//	// for debugging
//	printf("xCellNum: %ld, yCellNum: %ld\n", xCellNum, yCellNum);

	if (xCellNum < CELLBLK || yCellNum < CELLBLK)
	{
		CELLBLK = (xCellNum < yCellNum) ? xCellNum : yCellNum ;
	}

// 	// for debugging
// 	printf("CELLBLK: %ld\n", CELLBLK);

	// 傫ȃZ(ZubN)̐
	long xBlkNum = (xCellNum%CELLBLK == 0)? 
		xCellNum/CELLBLK : xCellNum/CELLBLK + 1 ;
	long yBlkNum = (yCellNum%CELLBLK == 0)? 
		yCellNum/CELLBLK : yCellNum/CELLBLK + 1 ;

// 	// for debugging
//  	printf("xBlkNum: %ld, yBlkNum: %ld\n", xBlkNum, yBlkNum);

	for (long m = 0; m < numOfTotalEdges; m++)
	{
		// _-_GbWȊO̓XLbv
		if (edgeArray[m].Atr() != 1) continue;

		// edgeArray[m] ̈ʒu
		double x = edgeArray[m].X();
		double y = edgeArray[m].Y();

		double xl, xu, yl, yu;

		// ǂ̃ZubNɂ邩T
		for (long I = 0; I < xBlkNum; I++)
		{
			xl = mXorig+(double)I*(double)CELLBLK*mDx;
			xu = mXorig+(double)(I+1)*(double)CELLBLK*mDx;

// 			// for debugging
// 			printf("xl: %f, xu: %f\n", xl, xu);

			for (long J = 0; J < yBlkNum; J++)
			{
				yl = mYorig+(double)J*(double)CELLBLK*mDy;
				yu = mYorig+(double)(J+1)*(double)CELLBLK*mDy;

				// 
				if (xl <= x && x < xu && yl <= y && y < yu)
				{
					// ǂ̃Zɂ邩T

					double wXorig = mXorig + (double)I*(double)CELLBLK*mDx;
					double wYorig = mYorig + (double)J*(double)CELLBLK*mDy;

					for (long i = 0; i < CELLBLK; i++)
					{
						if (CELLBLK*I + i >= xCellNum)
						{
							Eprint(__FILE__, __LINE__);
							// KsEdgeFc2d::Initial_output
							fprintf(stderr, "Can not find the cell which includes the slope unit %ld,\n", edgeArray[m].Num());
							fprintf(stderr, "which is located at [%f, %f].\n", x, y);
							Oprint();
							exit(1);
						}

						xl = wXorig+(double)i*mDx;
						xu = wXorig+(double)(i+1)*mDx;

						for (long j = 0; j < CELLBLK; j++)
						{
// 							if (CELLBLK*J + j >= yCellNum)
// 							{
// 								Eprint(__FILE__, __LINE__);
// 									// KsEdgeFc2d::Initial_output
// 									// Can not find the cell which includes
// 									// the slope unit.
// 								fprintf(stderr, "The slope unit is located at [%f, %f].\n", x, y);
// 								Oprint();
// 								exit(1);
// 							}

							// ̈̒[܂ŗ̂Ŏ x ɐi
							if (CELLBLK*J + j >= yCellNum)
							{
								goto NEXTX;
							}

							yl = wYorig+(double)j*mDy;
							yu = wYorig+(double)(j+1)*mDy;

							// 
							if (xl <= x && x < xu && yl <= y && y < yu)
							{
								edgeArray[m].Gx(CELLBLK*I + i);
								edgeArray[m].Gy(CELLBLK*J + j);

// 								// for debugging
//								printf("edge %ld [%ld, %ld]\n", 
// 									   edgeArray[m].Num(),
// 									   edgeArray[m].Gx(), edgeArray[m].Gy());
//								printf("Rainblock [%ld, %ld]\n",
//									   CELLBLK*I + i, CELLBLK+J + j);

								goto NEXTEDGE;
							}
						}
				  		NEXTX:;
					}
				}
			}
		}

		// GbWZubN邱ƂłȂ
		Eprint(__FILE__, __LINE__);
		// KsEdgeFc2d::Initial_output
		fprintf(stderr, "    Cannot find the cell block in which\n");
		fprintf(stderr, "    the edge %ld (%f, %f) is included.\n", 
				edgeArray[m].Num(), edgeArray[m].X(), edgeArray[m].Y());
		Oprint();
		exit(1);

		// GbWZ𔭌邱Ƃł̂ŁÃGbW̏
		// ɐi
	  	NEXTEDGE:;
	}

	// vZJnɂo

	totalRain = 0;
	totalArea = 0;

	for (long i = 0; i < numOfTotalEdges; i++)
	{
		if (edgeArray[i].Atr() == 1)
		{
			totalArea += edgeArray[i].Area();
			totalRain += (wRain(edgeArray[i].Gx(), edgeArray[i].Gy()))
						/ 1000.0 / 3600.0	// Pʕϊ F mm/h -> m/sec
						* edgeArray[i].Area();	// P F m^3/sec

			if (wRain(edgeArray[i].Gx(), edgeArray[i].Gy()) < -5.0)
			{
				Eprint(__FILE__, __LINE__);
				fprintf(stderr, "    the edge (%ld, %ld) is included.\n", 
				edgeArray[i].Gx(), edgeArray[i].Gy());
				fprintf(stderr, "    which is (%f, %f).\n", 
				edgeArray[i].X(), edgeArray[i].Y());
				//exit(1);
			}
		}
	}
	averageRain = totalRain / totalArea * 1000.0 * 3600.0;
	sp.Send_data(current_time, averageRain);
	spSum.Send_data(current_time, sumRain);
	printf("Area (by rainOnCatchment): %f [km2]\n", totalArea/1000000.0);

	return (Boolean)YES;
}

//  ͂ZāCM[qɏo //////////////////////
Boolean rainOnCatchment::Calculate(void)
{
	void* fdp; void* ldp;
	if (rp.Get_data_pack(fdp, current_time + time_step, ldp) == NO)
		return NO;

	//time_t ft, lt;
	//KhDMatrix fRain, lRain;
	time_t lt;
	KhDMatrix lRain;
	//ft = ((Data<KhDMatrix>*)fdp)->Data_time();
	lt = ((Data<KhDMatrix>*)ldp)->Data_time();
	//fRain = ((Data<KhDMatrix>*)fdp)->Value();
	lRain = ((Data<KhDMatrix>*)ldp)->Value();
	mRainn = ((Data<KhDMatrix>*)ldp)->Value();

	//time_t tt = current_time + time_step;
	
	//if (tt == ft)
	//{
	//	mRainn = fRain;
	//}
	//else if (tt == lt)
	//{
		mRainn = lRain;
	//}
	//else
	//{
	//	fRain *= (double)(lt-tt)/(double)(lt-ft);
	//	lRain *= (double)(tt-ft)/(double)(lt-ft);
	//
	//	mRainn = fRain + lRain;
	//}

	totalRain = 0;

	for (long i = 0; i < numOfTotalEdges; i++)
	{
		totalRain += (mRainn(edgeArray[i].Gx(), edgeArray[i].Gy()))
					/ 1000.0 / 3600.0		// Pʕϊ : mm/h -> m/sec
					* edgeArray[i].Area();	// P F m^3/sec
	}
	averageRain += totalRain / totalArea * 1000.0 * 3600.0;
	sumRain += totalRain / totalArea * 1000.0 * time_step;
	aveCount += 1;

	// o
	if(aveCount == aveNum)
	{
		aveCount = 0;
		sp.Send_data(current_time + time_step, averageRain / double(aveNum));
		//printf("rainOnCatchment : %ld, averageRain : %f\n", current_time + time_step, averageRain);
		averageRain = 0;

		spSum.Send_data(current_time + time_step, sumRain);
		//printf("rainOnCatchment : %ld, sumRain : %f\n", current_time + time_step, sumRain);
	}
	return (Boolean)YES;
}