/* rainOnCatchment.h */

#if !defined(rainOnCatchment_h)
#define rainOnCatchment_h

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "khmatrix.h" // This file must be included before p_tmp.h.

#include "common.h"				// ʊ̒`
#include "element.h"            // NX Element ̒`
#include "p_tmp.h"              // NX Receive, Send ̒`
#include "khrbktree.h"

typedef KhKeyedData<long,Edge*> KeyData;
typedef KhMatrix<double> KhDMatrix;

class rainOnCatchment : public Element
{

// p^
  protected:

	int numOfSubCatchment;		// 㗬̕搔
	int* mSubNum;				// 㗬̕ԍ
	long numOfTotalEdges;		// Edge

	int mDt;					// o͎ԊԊu(p^œǂݍ) (sec)
	int mDDt;					// vZԊԊu(600secɌŒ) (sec)
	int aveNum;					// mDt / mDDt

	double mXorig, mYorig;		// 2Jʃf[^̌_
	double mDx;					// 2Jʃf[^̃x
	double mDy;					// 2Jʃf[^̃y

	Edge* edgeArray;			// Edge ̔zւ̃|C^

	KhDMatrix mRainn;			// next time ł̍~x (mm/hour)
	int mTopoDataType;			// Ζʒn`f[^̎ނ\ϐ

// ԗ

	double totalRain;			// Ώۗ~Jʁim^3/sec)
	double totalArea;			// Ώۗʐ (m^2)
	double averageRain;			// Ώۗύ~Jx (mm/h)
	double sumRain;				// ΏۗώZ~J (mm)
	int aveCount;				// aveCountaveNumɂȂƂɏo

// M[qEM[q

  protected:

	ReceiveNointp<KhDMatrix> rp;     // z~Jx
	Send<double> sp;        // 敽ύ~Jx
	Send<double> spSum;     // ώZ~J

  protected:

	void Register_receive_ports(void)
	{
		Register((void*) &rp);
	}

	void Register_send_ports(void)
	{
		Register((void*) &sp);
		Register((void*) &spSum);
	}

// ֐ERXgN^EfXgN^

  private:
	// ֎~邽߂̐錾B܂B
	rainOnCatchment& operator=(const rainOnCatchment& rhs);

  public:

	// ֐
	Boolean Init(char* o_name, int o_num)
	// o_name 	IuWFNg
	// o_num  	IuWFNgԍ
	{ return Element::Init(o_name, o_num); }

	// tRXgN^
	rainOnCatchment(char* o_name, int o_num) : Element()
	{
		class_name = "rainOnCatchment";
		Init(o_name, o_num);
		rp.Init("rp", 0);
		sp.Init("sp", 0);
		spSum.Init("spSum", 0);
	}

	// RXgN^
	rainOnCatchment() : Element()
	{
		class_name = "rainOnCatchment";
		rp.Init("rp", 0);
		sp.Init("sp", 0);
		spSum.Init("spSum", 0);
	}

	// fXgN^
	~rainOnCatchment(void) {}

	// for SCF-style model building
	//////////////////////////////////////////////////////////////////////
	// Returns a pointer to a new rainOnCatchment
	rainOnCatchment* NewElement() { return (new rainOnCatchment()); }
    Boolean Init(char* o_name, int o_num, FILE*) 
	{ return Init(o_name, o_num); }

// p[^̐ݒEԗʂ̏

  public:

	void Set_parameter(FILE* fp);

	void Set_initial_state(FILE* fp)
	{
	    time_t tnow;
	    if (fscanf(fp, "%ld %lf", &tnow, &sumRain) != 2) {
	        Eprint(__FILE__, __LINE__,
	              "Cannot scan infomation for initializing.");
	        fprintf(stderr, "object '%s %d'"
	              " : rainOnLake::Set_initial_state\n",
	              object_name, object_number);
	        exit(1);
	    }
	    if (tnow > 0) current_time = tnow;

		totalRain = 0;
		totalArea = 0;
		averageRain = 0;
		aveCount = 0;
	}

	// lŗ^֐
	void Set_initial_state(time_t ct)
	{
		if (ct > 0) current_time = ct;
	}

	void Save_terminal_state(FILE* fp)
	{
		assert(fp != NULL);
		fprintf(fp, "%ld %f \n", current_time, sumRain);
	}

  public:

	Boolean Initial_output(void);
	// ̓͂ZāCM[qɏo܂B

	time_t Calculate_time_step(void) {return mDDt; } // mDt -> mDDt ɕύXD

	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }

	Boolean Work(void)
	{ return Work0(); }

	Boolean Calculate(void);
};

#endif