/*;  trainOnCatchment.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */
// trainOnCatchment.cc

#include <stdio.h>
#include <time.h>

// This file has to be included before p_tmp.h.
#include "ksedgefc2d.h"                // class Edge ̒`
#include "rainOnCatchment.h"           // class rainOnCatchment ̒`

#include "total.h"
#include "p_tmp.h"
#include "i_file_matrix.h"

// NX VirtualRiverBasin ̒`

class VirtualRiverBasin : public Total_system
{

 protected:

  // ͒[q
  I_file_matrix<KhDMatrix> ip;  // ~x (mm/hr)

  // ͒[q̓o^
  void Register_input_ports(void)
  {
    Register((void*) &ip);
  }

 protected:
 
  // o͒[q
  O_file<double> op;

  // o͒[q̓o^
  void Register_output_ports(void)
  {
    Register((void*) &op);
  }

 protected:
  // \vf
  rainOnCatchment rainonCatchment;

  // \vf̓o^
  void Register_components(void);

  // vfԔvZp̊֐Ȃ̂ŁAgȂ
  void Register_iterators(void) {}

 protected:
  // [q̐ڑ
  void Connect_ports(void);

  // ڒʐMp̊֐Ȃ̂ŁAgȂ
  void Connect_components(void) {}

 public:
  // Ԃ̐ݒ
  virtual void Set_initial_state(FILE* fp)
  {
    fscanf(fp, "%ld", &current_time);
  }

 public:
   // RXgN^
   VirtualRiverBasin(void);
};




// \vf̓o^
void VirtualRiverBasin::Register_components(void)
{
  Register((void*) &rainonCatchment);
}


// [q̐ڑ
void VirtualRiverBasin::Connect_ports(void)
{
	Connect(((void*) &ip), ((void*) &rainonCatchment), "ReceiveNointp", "rp", 0);
	Connect(((void*) &rainonCatchment), "Send", "sp", 0, ((void*) &op));
}

// RXgN^
VirtualRiverBasin::VirtualRiverBasin(void)
   :    Total_system(),
        ip("../ksedgefc2d/raindata/rain2_90091723.dat"),
        op("trainOnCatchment.out"),
        rainonCatchment("rainonCatchment", 0)
{
    class_name = "VirtualRiverBasin";

    // ŠnNX 
    // ("IuWFNg", "IuWFNgԍ", "vZO[v̐")
    Init("vrb", 0, 0);
}


// CvO

int main(void)
{
    VirtualRiverBasin vrb;		// Šnf

    if (vrb.Construct() != YES)
        { printf("\n# Failure : Construct.\n"); return 1; }

    if (vrb.Switch() != YES)
        { printf("\n# Failure : Switch.\n"); return 1; }
    
    if (vrb.Are_you_ready() != YES)
        { printf("\n# Failure : Are_you_ready.\n"); return 1; }
    
    // p^t@Cǂ݂Ƃ
    vrb.Read_parameter_file("trainOnCatchment.pmt");

    // Ԃt@Cǂ݂Ƃ
    vrb.Read_initial_state_file("trainOnCatchment.ist");

    // M[qf[^XgA
    vrb.Read_send_port_file("trainOnCatchment.isd");

    vrb.Initial_work();
    vrb.Work();

    // ŏIԂt@Cɕۑ
    vrb.Write_terminal_state("trainOnCatchment.tst");

    // M[qɎcĂf[^t@Cɕۑ
    vrb.Write_send_port_stock("trainOnCatchment.tsd");
    return 0;
}
